#!/usr/bin/env python
import os, stat, sys, platform, subprocess
home = 'https://subversion.xor.aps.anl.gov/EXPGUI/'
proxycmds = []
if os.path.exists("proxyinfo.txt"):
    os.remove("proxyinfo.txt")
ans = raw_input("Enter the proxy address [none needed]: ")
if ans.strip() != "":
    proxycmds.append('--config-option')
    proxycmds.append('servers:global:http-proxy-host='+ans.strip())
    fp = open("proxyinfo.txt",'w')
    fp.write(ans.strip()+'\n')
    ans = raw_input("Enter the proxy port [8080]: ")
    if ans.strip() == "": ans="8080"
    proxycmds.append('--config-option')
    proxycmds.append('servers:global:http-proxy-port='+ans.strip())
    fp.write(ans.strip()+'\n')
    fp.close()
gsaspath = os.path.split(sys.argv[0])[0]
gsaspath = os.path.abspath(os.path.expanduser(gsaspath))
print 'GSAS is being bootstrapped from repository to '+gsaspath
print 'Determining system type...',
if sys.platform.startswith('linux'):
    if platform.processor().find('86') <= -1:
        ans = raw_input("Note, GSAS requires an Intel-compatible processor and 32-bit"
                        "libraries.\nAre you sure want to continue? [Yes]/no: ")
        if ans.lower().find('no') > -1: sys.exit()
    repos = 'linux'
    print 'Linux, Intel-compatible'
elif sys.platform == "darwin" and platform.processor() == 'i386':
    repos = 'osxi86'
    print 'Mac OS X, Intel-compatible'
elif sys.platform == "darwin":
    repos = 'osxppc'
    print 'Mac OS X, PowerPC'
else:
    raise Exception('Undefined system type')
print 'OK'

print 'Checking for subversion...',
try: 
    #p = subprocess.call(['svn','status'],stdout=subprocess.PIPE)
    p = subprocess.Popen(['svn','help','switch'],stdout=subprocess.PIPE)
except:
    raise Exception('Subversion (svn) not found. Use "yum install svn" or "dpkg",...')
res = p.stdout.read()
if res.find('--ignore-ancestry') == -1:
    print ' svn <=1.6 OK'
    svnopt = ''
else:
    svnopt = '--ignore-ancestry'
    print ' svn >=1.7 OK'

cmds = (
    (['svn', 'co', home+ 'gsas/all', gsaspath],'loading GSAS common'),
    (['svn', 'switch', home+ 'trunk/', gsaspath+'/expgui'],'loading EXPGUI'),
    (['svn', 'switch', home+ 'gsas/' + repos+ '/exe/', gsaspath+'/exe'],'loading GSAS programs'),
    (['svn', 'switch', home+ 'gsas/' + repos+ '/pgl/', gsaspath+'/pgl'],'loading PGPLOT files'),
)

for cmd,msg in cmds: 
    print 70*'*'
    print msg + ' from ' + cmd[2]
    for item in cmd: print item,
    print ""
    if svnopt: cmd += [svnopt]
    p = subprocess.call(cmd)

if sys.platform.startswith('linux'):
    os.chmod(gsaspath + "/expgui/expgui", 
             stat.S_IXUSR | stat.S_IRUSR | stat.S_IRGRP | stat.S_IXGRP | stat.S_IXOTH) 
    if os.path.exists(os.path.expanduser('~/Desktop/')):
        open(os.path.expanduser('~/Desktop/EXPGUI.desktop'),'w').write('''
[Desktop Entry]
Encoding=UTF-8
Version=1.0
Type=Application
Terminal=false
Exec=%s/expgui/expgui
Name=EXPGUI
Icon=%s/EXPGUI.png
''' % (gsaspath,gsaspath))
        os.chmod(os.path.expanduser('~/Desktop/EXPGUI.desktop'),
                 stat.S_IWUSR | stat.S_IXUSR | stat.S_IRUSR | stat.S_IRGRP | stat.S_IXGRP | stat.S_IXOTH) 
        open(os.path.expanduser('~/Desktop/GSAS.desktop'),'w').write('''
[Desktop Entry]
Encoding=UTF-8
Version=1.0
Type=Application
Terminal=true
Exec=%s/GSAS
Name=GSAS
Icon=%s/GSAS.png
''' % (gsaspath,gsaspath))
        os.chmod(os.path.expanduser('~/Desktop/GSAS.desktop'),
                 stat.S_IWUSR | stat.S_IXUSR | stat.S_IRUSR | stat.S_IRGRP | stat.S_IXGRP | stat.S_IXOTH) 
